=== debian/changelog ===
st (1.9-3.4) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches/02-implicit-declarations.patch: Fix an improper macro
    feature check. Thanks to Zixing Liu <zixing.liu@canonical.com>.
    (Closes: #1065797, #1066287, LP: #2060973)
  * debian/patches/1032955_riscv_support.patch: Add support for RISC-V
    CPU. Thanks to Steven Liu <liuqi05@kuaishou.com>.
    (Closes: #1032955, LP: #2061639)
  * Switch from transitional pkg-config to pkgconf.
  * Whitespace cleanup.

 -- Andreas Beckmann <anbe@debian.org>  Thu, 18 Apr 2024 15:28:28 +0200

st (1.9-3.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062924

 -- Benjamin Drung <bdrung@debian.org>  Thu, 29 Feb 2024 17:29:25 +0000

st (1.9-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches: Add patch to fix FTBFS on AArch64.
    (Closes: #791928)
  * debian/patches: Migrate from CDBS simplepatch to "3.0 (quilt)" patch
    handling.
  * debian/control:
    + Properly place Homepage field to have information properly identified
      by the package tracking system.
  * debian/source/format: Use "3.0 (quilt)" source format.

 -- Boyuan Yang <byang@debian.org>  Sat, 20 Jun 2020 19:31:02 -0400

st (1.9-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fixed a FTBFS caused by a missing separator in debian/rules.
   (Closes: #750291)

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 08 Nov 2014 22:48:09 -0200

st (1.9-3) unstable; urgency=low

  * Fixed doc-base registration for auxiliary documents.

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Sun, 01 Nov 2009 03:23:44 +0100

st (1.9-2) unstable; urgency=low

  * Switched to cdbs
  * Appease lintian (homepage, description, symbols)
  * Patch the library to hide all symbols of the form _st_*
  * Added documentation to doc-base

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Sun, 01 Nov 2009 02:39:09 +0100

st (1.9-1) unstable; urgency=low

  * New upstream release (closes: #422103)
  * Updated Standards-Version

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Tue, 20 Oct 2009 02:41:52 +0200

st (1.7-1) unstable; urgency=low

  * New upstream release (closes: #406394)
  * Increased standards-version; no changes necessary
  * Moved from DH_COMPAT level 2 to 5; no changes necessary
  * Added linker options to indicate that an executable stack is not needed
  * Downgraded optimization to -O2

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Sun, 14 Jan 2007 21:36:45 +0100

st (1.5.1-2) unstable; urgency=low

  * Changed section to libdevel

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Sun, 29 Aug 2004 16:40:26 +0200

st (1.5.1-1) unstable; urgency=low

  * New upstream release
  * Includes amd64 support (closes: #262301)

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Sun, 29 Aug 2004 15:52:25 +0200

st (1.4-1) unstable; urgency=low

  * New upstream release
  * Old bug was closed long ago (closes: #138173)

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Sat,  4 Jan 2003 20:25:12 +0000

st (1.3pre4c-1) unstable; urgency=low

  * New upstream release: 1.4c (stable will be 1.4)
  * Patches for s390 and hppa are upstream so dropped from the package.

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Sat, 26 Oct 2002 19:18:55 +0000

st (1.3pre4b-3) unstable; urgency=low

  * Added patch for s390

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Sat, 26 Oct 2002 19:18:29 +0000

st (1.3pre4b-2) unstable; urgency=low

  * Fixed section override disparity
  * Changed maintainer address to @debian.org

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Sun, 11 Aug 2002 17:46:10 +0000

st (1.3pre4b-1) unstable; urgency=low

  * New upstream release: 1.4b (stable will be 1.4)
  * Include fix from Randolph Chung for hppa. (closes: #138173) Thanks!

 -- Wesley W. Terpstra (Debian) <terpstra@debian.org>  Sun, 11 Aug 2002 16:38:13 +0000

st (1.3-2) unstable; urgency=low

  * Added a conflicts with the sox-dev package and sox versions prior to the
    split. This avoids the libst.a and st.h in sox.
  * (closes: #132387) ITP
  * Got the package to work on sparc. For some reason, when optimizing, we
    must specify -finline-functions or else the optimization will cause the
    context switch to crash. -O3 implies -finline-functions so use it.
  * Use gcc for linking so that systems which need -lgcc get it.
  * Stole code from mozilla to handle architectures of linux other than
    those with canned JB_SP defines.
  * mips is a pain; we have to use a custom MD_INIT_CONTEXT
  * Builds now work on sparc, arm, alpha, powerpc, ia64, i386, mipsel, mips.
  * Special thanks to Ryan Murray (neuro) for needed resources to port
    libst to the above platforms!

 -- Wesley W. Terpstra <wesley@terpstra.ca>  Fri, 22 Feb 2002 03:47:28 +0000

st (1.3-1) unstable; urgency=low

  * Initial Release.

 -- Wesley W. Terpstra <wesley@terpstra.ca>  Sun,  9 Dec 2001 00:51:25 -0800
