=== debian/control ===
Source: st
Section: devel
Priority: optional
Maintainer: Wesley W. Terpstra (Debian) <terpstra@debian.org>
Build-Depends:
 debhelper (>= 7.0.0),
 cdbs (>= 0.4.52),
 autotools-dev,
# prevent accidental backports after the 64-bit time_t transition
 dpkg-dev (>= 1.22.5),
Standards-Version: 3.8.3.0
Homepage: http://state-threads.sourceforge.net/

Package: libst-dev
Section: libdevel
Architecture: any
Depends: libst1t64 (= ${binary:Version}), ${misc:Depends}, libc6-dev
Recommends: pkgconf
Conflicts: sox (<= 12.17.2-1), sox-dev
Description: State Threads Library - Development files
 The State Threads library has an interface similar to POSIX threads.
 .
 However, the threads are actually all run in-process. This type of
 threading allows for controlled schedualing points. It is highly useful
 for designing robust and extremely scalable internet applications since
 there is no resource contention and locking is generally unnecessary.
 .
 It can be combined with traditional threading or multiple process
 parallelism to take advantage of multiple processors.
 .
 This package contains the development files for compiling programs.

Package: libst1t64
Provides: ${t64:Provides}
Replaces: libst1
Breaks: libst1 (<< ${source:Version})
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: State Threads Library
 The State Threads library has an interface similar to POSIX threads.
 .
 However, the threads are actually all run in-process. This type of
 threading allows for controlled schedualing points. It is highly useful
 for designing robust and extremely scalable internet applications since
 there is no resource contention and locking is generally unnecessary.
 .
 It can be combined with traditional threading or multiple process
 parallelism to take advantage of multiple processors.
 .
 This package provides the library required by dependent programs.
