=== debian/watch ===
version=3

http://sf.net/state-threads/st-([\d\.]+)\.tar\.gz
